import torch
from numba import cuda
import math


def getblocks(threads, shape):
    blocks = []
    for t, n in zip(threads, shape):
        b = n # t
        if (n % t != 0):
            b += 1
        blocks.append(b)

    return blocks


#
# ---- Forward
#

@cuda.jit()
def cuda_forward(output: torch.Tensor, x: torch.Tensor, y: torch.Tensor, p: float, eps: float):
    i = cuda.blockIdx.x * cuda.blockDim.x + cuda.threadIdx.x
    j = cuda.blockIdx.y * cuda.blockDim.y + cuda.threadIdx.y

    if i < output.shape[0] and j < output.shape[1]:
        #  TODO:  Calcul de la distance output[i][j] = d_p(x_i, x_j)
        pass

def forward(nthreads, x, y, p, eps):
    # Alloue l'espace mémoire pour la sortie
    output = torch.empty(x.size(0), y.size(0), device=x.device, dtype=x.dtype)

    # Chaque block aura nthreads x nthreads processus en parallèle
    threadsperblock = (nthreads, nthreads)

    # Récupère le nombre de blocs nécessaires pour couvrir "output"
    blockspergrid = getblocks(threadsperblock, output.shape)

    # Appelle le noyau CUDA
    cuda_forward[blockspergrid, threadsperblock](output, x.detach(), y.detach(), float(p), float(eps))
    return output

#
# ---- Backward
#

#  TODO:  Implémenter le noyau cuda_backward


def backward(nthreads, grad_output, output, x, y, p, eps):
    # Allocation mémoire pour les gradients gradx et grady
    x = x.detach()
    y = y.detach()

    gradx = torch.empty_like(x)
    grady = torch.empty_like(y)

    threads = (nthreads, nthreads)

    #  TODO:  Préparation des structures + appel du noyau (2 fois, pour gradx et grady)

    return gradx, grady
