import math

from torch import nn
from torch.autograd import Function
import torch
import torch.nn.functional as F

def distances(x, y, p: int = 2, eps: float = 1e-16):
    l = []
    for i, x in enumerate(x):
        l.append(F.pairwise_distance(x.view(1, -1).expand_as(y), y, p=p, eps=eps))

    return torch.stack(l)

